/*
 * sqliteInt.h
 *
 *  A stub header, used in the tokenizer, to emulate the interface to the
 *  tokenizer from sqlite.
 *
 *  This is implemented instead of modifying the existing tokenizer, to keep
 *  updates easier.
 */

#ifndef SQLITEINT_H_
#define SQLITEINT_H_

#define SQLITE_ASCII

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>

#include <sqlextract/parser.h>


#ifndef TK_SEMI
#define TK_SEMI -1
#endif

#ifndef TK_DOT
#define TK_DOT -1
#endif

/*
** The following macros mimic the standard library functions toupper(),
** isspace(), isalnum(), isdigit() and isxdigit(), respectively. The
** sqlite versions only work for ASCII characters, regardless of locale.
*/
#ifdef SQLITE_ASCII
# define sqlite3Toupper(x)  ((x)&~(sqlite3CtypeMap[(unsigned char)(x)]&0x20))
# define sqlite3Isspace(x)   (sqlite3CtypeMap[(unsigned char)(x)]&0x01)
# define sqlite3Isalnum(x)   (sqlite3CtypeMap[(unsigned char)(x)]&0x06)
# define sqlite3Isalpha(x)   (sqlite3CtypeMap[(unsigned char)(x)]&0x02)
# define sqlite3Isdigit(x)   (sqlite3CtypeMap[(unsigned char)(x)]&0x04)
# define sqlite3Isxdigit(x)  (sqlite3CtypeMap[(unsigned char)(x)]&0x08)
# define sqlite3Tolower(x)   (sqlite3UpperToLower[(unsigned char)(x)])
#else
# define sqlite3Toupper(x)   toupper((unsigned char)(x))
# define sqlite3Isspace(x)   isspace((unsigned char)(x))
# define sqlite3Isalnum(x)   isalnum((unsigned char)(x))
# define sqlite3Isalpha(x)   isalpha((unsigned char)(x))
# define sqlite3Isdigit(x)   isdigit((unsigned char)(x))
# define sqlite3Isxdigit(x)  isxdigit((unsigned char)(x))
# define sqlite3Tolower(x)   tolower((unsigned char)(x))
#endif

#define testcase(_X)

extern const unsigned char sqlite3UpperToLower[];
extern const unsigned char sqlite3CtypeMap[256];

#endif /* SQLITEINT_H_ */
