#include <sqlextract/format.h>
#include "default.h"

#include <stdio.h>
#include <stdlib.h>

struct default_format_t {
	int rownum;
};

static void *default_format_create(void *arg);
static void default_format_destroy(void *stg);
static void default_format_begin(void *stg);
static void default_format_end(void *stg);
static void default_format_row(void *stg);
static void default_format_field(void *stg, struct arbval_t *field);

struct output_formatter_desc_t default_formatter = { default_format_create,
		default_format_destroy, default_format_begin, default_format_end,
		default_format_row, default_format_field };

static void *default_format_create(void *arg) {
	struct default_format_t *storage = calloc(1,
			sizeof(struct default_format_t));
	storage->rownum = 0;
	return storage;
}

static void default_format_destroy(void *stg) {
	struct default_format_t *storage = (struct default_format_t *) stg;
	free(storage);
}

static void default_format_begin(void *stg) {
	struct default_format_t *storage = (struct default_format_t *) stg;
	storage->rownum = 0;
}

static void default_format_end(void *stg) {
	struct default_format_t *storage = (struct default_format_t *) stg;
	printf("\n");
	free(storage);
}

static void default_format_row(void *stg) {
	struct default_format_t *storage = (struct default_format_t *) stg;
	storage->rownum++;
	if (storage->rownum != 1) {
		printf("\n");
	}
}

static void default_format_field(void *stg, struct arbval_t *field) {

	switch (field->type) {
	case ARBVAL_TYPE_INTEGER:
		printf("%ld, ", field->value.integer);
		break;
	case ARBVAL_TYPE_NULL:
		printf("NULL, ");
		break;
	case ARBVAL_TYPE_REAL:
		printf("%f, ", field->value.real);
		break;
	case ARBVAL_TYPE_STRING:
		printf("\"%s\", ", field->value.string);
		break;
	}
}
